//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include "FBtSound.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas

__fastcall FBtSound::FBtSound(TComponent* Owner)
	: TGraphicControl(Owner){
 clicked = false;
 c = clGreen;
 FMouseOver = false;
 rect.Top = 0;
 rect.Left = 0;
 rect.Bottom = Height;
 rect.Right = Width;
}

namespace Fbtsound {
 void __fastcall Register()	{
  TComponentClass classes[1] = {__classid(FBtSound)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void __fastcall FBtSound::Paint() {
 if(FMouseOver) {
  if(Enabled) {
   if(clicked) { PaintClicked(); return; }
   if(!clicked) { PaintNormal(); return; }
  }
  if(!Enabled) { PaintDisabled(); return; }
 }
 if(!FMouseOver) {
  if(Enabled) { PaintNormalMouseNotOver(); return; }
  if(!Enabled) { PaintDisabledMouseNotOver(); return; }
 }
}

void __fastcall FBtSound::PaintClicked() {
 switch(FKind) {
  case Play: PaintClickedPlay(); return;
  case Stop: PaintClickedStop(); return;
 }
}

void __fastcall FBtSound::PaintNormal() {
 switch(FKind) {
  case Play: PaintNormalPlay(); return;
  case Stop: PaintNormalStop(); return;
 }
}

void __fastcall FBtSound::PaintNormalMouseNotOver() {
 switch(FKind) {
  case Play: PaintNormalPlayMouseNotOver(); return;
  case Stop: PaintNormalStopMouseNotOver(); return;
 }
}

void __fastcall FBtSound::PaintDisabled() {
 switch(FKind) {
  case Play: PaintDisabledPlay(); return;
  case Stop: PaintDisabledStop(); return;
 }
}

void __fastcall FBtSound::PaintDisabledMouseNotOver() {
 switch(FKind) {
  case Play: PaintDisabledPlayMouseNotOver(); return;
  case Stop: PaintDisabledStopMouseNotOver(); return;
 }
}

void __fastcall FBtSound::PaintClickedPlay() {
 r.Left = 0;
 r.Top = 0;
 r.Right = Width;
 r.Bottom = Height;
 Canvas->Brush->Color = clBlack;
 Canvas->FillRect(r);
 r.Left = 1;
 r.Top = 1;
 r.Right = Width-1;
 r.Bottom = Height-1;
 Canvas->Brush->Color = clGray;
 Canvas->FillRect(r);
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-1;
 r.Bottom = Height-1;
 Canvas->Brush->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Pen->Color = clLime;
 register int a = Width/2+3;
 register int b = Height/2+1;
 point(a-5,b-4);
 point(a-5,b-3);
 point(a-5,b-2);
 point(a-5,b-1);
 point(a-5,b);
 point(a-5,b+1);
 point(a-5,b+2);
 point(a-5,b+3);
 point(a-5,b+4);
 point(a-4,b-3);
 point(a-4,b-2);
 point(a-4,b-1);
 point(a-4,b);
 point(a-4,b+1);
 point(a-4,b+2);
 point(a-4,b+3);
 point(a-3,b-3);
 point(a-3,b-2);
 point(a-3,b-1);
 point(a-3,b);
 point(a-3,b+1);
 point(a-3,b+2);
 point(a-3,b+3);
 point(a-2,b-2);
 point(a-2,b-1);
 point(a-2,b);
 point(a-2,b+1);
 point(a-2,b+2);
 point(a-1,b-2);
 point(a-1,b-1);
 point(a-1,b);
 point(a-1,b+1);
 point(a-1,b+2);
 point(a,b-1);
 point(a,b);
 point(a,b+1);
 point(a+1,b-1);
 point(a+1,b);
 point(a+1,b+1);
 point(a+2,b);
 point(a+3,b);
 point(a-6,b-5);
 point(a-6,b-4);
 point(a-6,b-3);
 point(a-6,b-2);
 point(a-6,b-1);
 point(a-6,b);
 point(a-6,b+1);
 point(a-6,b+2);
 point(a-6,b+3);
 point(a-6,b+4);
 point(a-6,b+5);
 point(a-5,b-5);
 point(a-5,b+5);
 point(a-4,b-4);
 point(a-4,b+4);
 point(a-3,b-4);
 point(a-3,b+4);
 point(a-2,b-3);
 point(a-2,b+3);
 point(a-1,b-3);
 point(a-1,b+3);
 point(a,b+2);
 point(a,b-2);
 point(a+1,b+2);
 point(a+1,b-2);
 point(a+2,b+1);
 point(a+2,b-1);
 point(a+3,b+1);
 point(a+3,b-1);
 point(a+4,b);
 point(a+5,b);
 Canvas->Pen->Color = clGray;
 point(a-7,b-6);
 point(a-7,b-5);
 point(a-7,b-4);
 point(a-7,b-3);
 point(a-7,b-2);
 point(a-7,b-1);
 point(a-7,b);
 point(a-7,b+1);
 point(a-7,b+2);
 point(a-7,b+3);
 point(a-7,b+4);
 point(a-7,b+5);
 point(a-7,b+6);
 point(a-6,b-6);
 point(a-5,b-6);
 point(a-4,b-5);
 point(a-3,b-5);
 point(a-2,b-4);
 point(a-1,b-4);
 point(a,b-3);
 point(a+1,b-3);
 point(a+2,b-2);
 point(a+3,b-2);
 point(a+4,b-1);
 point(a+5,b-1);
 point(a+6,b);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 point(a-6,b+6);
 point(a-5,b+6);
 point(a-4,b+5);
 point(a-3,b+5);
 point(a-2,b+4);
 point(a-1,b+4);
 point(a,b+3);
 point(a+1,b+3);
 point(a+2,b+2);
 point(a+3,b+2);
 point(a+4,b+1);
 point(a+5,b+1);
 return;
}

void __fastcall FBtSound::PaintNormalPlay() {
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-2;
 r.Bottom = Height-2;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo(0,Height-1);
 Canvas->LineTo(0,0);
 Canvas->LineTo(Width-1,0);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 Canvas->MoveTo(1,Height-3);
 Canvas->LineTo(1,1);
 Canvas->LineTo(Width-2,1);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo(1,Height-2);
 Canvas->LineTo(Width-2,Height-2);
 Canvas->LineTo(Width-2,1);
 Canvas->Pen->Color = clBlack;
 Canvas->MoveTo(0,Height-1);
 Canvas->LineTo(Width-1,Height-1);
 Canvas->LineTo(Width-1,-1);
 Canvas->Pen->Color = c;
 register int a = Width/2+2;
 register int b = Height/2;
 point(a-5,b-4);
 point(a-5,b-3);
 point(a-5,b-2);
 point(a-5,b-1);
 point(a-5,b);
 point(a-5,b+1);
 point(a-5,b+2);
 point(a-5,b+3);
 point(a-5,b+4);
 point(a-4,b-3);
 point(a-4,b-2);
 point(a-4,b-1);
 point(a-4,b);
 point(a-4,b+1);
 point(a-4,b+2);
 point(a-4,b+3);
 point(a-3,b-3);
 point(a-3,b-2);
 point(a-3,b-1);
 point(a-3,b);
 point(a-3,b+1);
 point(a-3,b+2);
 point(a-3,b+3);
 point(a-2,b-2);
 point(a-2,b-1);
 point(a-2,b);
 point(a-2,b+1);
 point(a-2,b+2);
 point(a-1,b-2);
 point(a-1,b-1);
 point(a-1,b);
 point(a-1,b+1);
 point(a-1,b+2);
 point(a,b-1);
 point(a,b);
 point(a,b+1);
 point(a+1,b-1);
 point(a+1,b);
 point(a+1,b+1);
 point(a+2,b);
 point(a+3,b);
 point(a-6,b-5);
 point(a-6,b-4);
 point(a-6,b-3);
 point(a-6,b-2);
 point(a-6,b-1);
 point(a-6,b);
 point(a-6,b+1);
 point(a-6,b+2);
 point(a-6,b+3);
 point(a-6,b+4);
 point(a-6,b+5);
 point(a-5,b-5);
 point(a-5,b+5);
 point(a-4,b-4);
 point(a-4,b+4);
 point(a-3,b-4);
 point(a-3,b+4);
 point(a-2,b-3);
 point(a-2,b+3);
 point(a-1,b-3);
 point(a-1,b+3);
 point(a,b+2);
 point(a,b-2);
 point(a+1,b+2);
 point(a+1,b-2);
 point(a+2,b+1);
 point(a+2,b-1);
 point(a+3,b+1);
 point(a+3,b-1);
 point(a+4,b);
 point(a+5,b);
 Canvas->Pen->Color = clGray;
 point(a-7,b-6);
 point(a-7,b-5);
 point(a-7,b-4);
 point(a-7,b-3);
 point(a-7,b-2);
 point(a-7,b-1);
 point(a-7,b);
 point(a-7,b+1);
 point(a-7,b+2);
 point(a-7,b+3);
 point(a-7,b+4);
 point(a-7,b+5);
 point(a-7,b+6);
 point(a-6,b-6);
 point(a-5,b-6);
 point(a-4,b-5);
 point(a-3,b-5);
 point(a-2,b-4);
 point(a-1,b-4);
 point(a,b-3);
 point(a+1,b-3);
 point(a+2,b-2);
 point(a+3,b-2);
 point(a+4,b-1);
 point(a+5,b-1);
 point(a+6,b);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 point(a-6,b+6);
 point(a-5,b+6);
 point(a-4,b+5);
 point(a-3,b+5);
 point(a-2,b+4);
 point(a-1,b+4);
 point(a,b+3);
 point(a+1,b+3);
 point(a+2,b+2);
 point(a+3,b+2);
 point(a+4,b+1);
 point(a+5,b+1);
 return;
}

void __fastcall FBtSound::PaintNormalPlayMouseNotOver() {
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-2;
 r.Bottom = Height-2;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Pen->Color = c;
 register int a = Width/2+2;
 register int b = Height/2;
 point(a-5,b-4);
 point(a-5,b-3);
 point(a-5,b-2);
 point(a-5,b-1);
 point(a-5,b);
 point(a-5,b+1);
 point(a-5,b+2);
 point(a-5,b+3);
 point(a-5,b+4);
 point(a-4,b-3);
 point(a-4,b-2);
 point(a-4,b-1);
 point(a-4,b);
 point(a-4,b+1);
 point(a-4,b+2);
 point(a-4,b+3);
 point(a-3,b-3);
 point(a-3,b-2);
 point(a-3,b-1);
 point(a-3,b);
 point(a-3,b+1);
 point(a-3,b+2);
 point(a-3,b+3);
 point(a-2,b-2);
 point(a-2,b-1);
 point(a-2,b);
 point(a-2,b+1);
 point(a-2,b+2);
 point(a-1,b-2);
 point(a-1,b-1);
 point(a-1,b);
 point(a-1,b+1);
 point(a-1,b+2);
 point(a,b-1);
 point(a,b);
 point(a,b+1);
 point(a+1,b-1);
 point(a+1,b);
 point(a+1,b+1);
 point(a+2,b);
 point(a+3,b);
 point(a-6,b-5);
 point(a-6,b-4);
 point(a-6,b-3);
 point(a-6,b-2);
 point(a-6,b-1);
 point(a-6,b);
 point(a-6,b+1);
 point(a-6,b+2);
 point(a-6,b+3);
 point(a-6,b+4);
 point(a-6,b+5);
 point(a-5,b-5);
 point(a-5,b+5);
 point(a-4,b-4);
 point(a-4,b+4);
 point(a-3,b-4);
 point(a-3,b+4);
 point(a-2,b-3);
 point(a-2,b+3);
 point(a-1,b-3);
 point(a-1,b+3);
 point(a,b+2);
 point(a,b-2);
 point(a+1,b+2);
 point(a+1,b-2);
 point(a+2,b+1);
 point(a+2,b-1);
 point(a+3,b+1);
 point(a+3,b-1);
 point(a+4,b);
 point(a+5,b);
 Canvas->Pen->Color = clGray;
 point(a-7,b-6);
 point(a-7,b-5);
 point(a-7,b-4);
 point(a-7,b-3);
 point(a-7,b-2);
 point(a-7,b-1);
 point(a-7,b);
 point(a-7,b+1);
 point(a-7,b+2);
 point(a-7,b+3);
 point(a-7,b+4);
 point(a-7,b+5);
 point(a-7,b+6);
 point(a-6,b-6);
 point(a-5,b-6);
 point(a-4,b-5);
 point(a-3,b-5);
 point(a-2,b-4);
 point(a-1,b-4);
 point(a,b-3);
 point(a+1,b-3);
 point(a+2,b-2);
 point(a+3,b-2);
 point(a+4,b-1);
 point(a+5,b-1);
 point(a+6,b);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 point(a-6,b+6);
 point(a-5,b+6);
 point(a-4,b+5);
 point(a-3,b+5);
 point(a-2,b+4);
 point(a-1,b+4);
 point(a,b+3);
 point(a+1,b+3);
 point(a+2,b+2);
 point(a+3,b+2);
 point(a+4,b+1);
 point(a+5,b+1);
 Canvas->Brush->Color = clGray;
 Canvas->FrameRect(rect);
 return;
}

void __fastcall inline FBtSound::point(int x, int y) {
 Canvas->MoveTo(x-1,y-1);
 Canvas->LineTo(x,y);
 return;
}

void __fastcall FBtSound::SetChecked(bool b) {
 FChecked = b;
 if (b) { c = clLime; Repaint(); return; }
 if (!b) { c = clGreen; Repaint(); return; }
}

void __fastcall FBtSound::PaintDisabledPlay() {
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-2;
 r.Bottom = Height-2;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo(0,Height-1);
 Canvas->LineTo(0,0);
 Canvas->LineTo(Width-1,0);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 Canvas->MoveTo(1,Height-3);
 Canvas->LineTo(1,1);
 Canvas->LineTo(Width-2,1);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo(1,Height-2);
 Canvas->LineTo(Width-2,Height-2);
 Canvas->LineTo(Width-2,1);
 Canvas->Pen->Color = clBlack;
 Canvas->MoveTo(0,Height-1);
 Canvas->LineTo(Width-1,Height-1);
 Canvas->LineTo(Width-1,-1);
 Canvas->Pen->Color = clSilver;
 register int a = Width/2+2;
 register int b = Height/2;
 point(a-5,b-4);
 point(a-5,b-3);
 point(a-5,b-2);
 point(a-5,b-1);
 point(a-5,b);
 point(a-5,b+1);
 point(a-5,b+2);
 point(a-5,b+3);
 point(a-5,b+4);
 point(a-4,b-3);
 point(a-4,b-2);
 point(a-4,b-1);
 point(a-4,b);
 point(a-4,b+1);
 point(a-4,b+2);
 point(a-4,b+3);
 point(a-3,b-3);
 point(a-3,b-2);
 point(a-3,b-1);
 point(a-3,b);
 point(a-3,b+1);
 point(a-3,b+2);
 point(a-3,b+3);
 point(a-2,b-2);
 point(a-2,b-1);
 point(a-2,b);
 point(a-2,b+1);
 point(a-2,b+2);
 point(a-1,b-2);
 point(a-1,b-1);
 point(a-1,b);
 point(a-1,b+1);
 point(a-1,b+2);
 point(a,b-1);
 point(a,b);
 point(a,b+1);
 point(a+1,b-1);
 point(a+1,b);
 point(a+1,b+1);
 point(a+2,b);
 point(a+3,b);
 point(a-6,b-5);
 point(a-6,b-4);
 point(a-6,b-3);
 point(a-6,b-2);
 point(a-6,b-1);
 point(a-6,b);
 point(a-6,b+1);
 point(a-6,b+2);
 point(a-6,b+3);
 point(a-6,b+4);
 point(a-6,b+5);
 point(a-5,b-5);
 point(a-5,b+5);
 point(a-4,b-4);
 point(a-4,b+4);
 point(a-3,b-4);
 point(a-3,b+4);
 point(a-2,b-3);
 point(a-2,b+3);
 point(a-1,b-3);
 point(a-1,b+3);
 point(a,b+2);
 point(a,b-2);
 point(a+1,b+2);
 point(a+1,b-2);
 point(a+2,b+1);
 point(a+2,b-1);
 point(a+3,b+1);
 point(a+3,b-1);
 point(a+4,b);
 point(a+5,b);
 Canvas->Pen->Color = clGray;
 point(a-7,b-6);
 point(a-7,b-5);
 point(a-7,b-4);
 point(a-7,b-3);
 point(a-7,b-2);
 point(a-7,b-1);
 point(a-7,b);
 point(a-7,b+1);
 point(a-7,b+2);
 point(a-7,b+3);
 point(a-7,b+4);
 point(a-7,b+5);
 point(a-7,b+6);
 point(a-6,b-6);
 point(a-5,b-6);
 point(a-4,b-5);
 point(a-3,b-5);
 point(a-2,b-4);
 point(a-1,b-4);
 point(a,b-3);
 point(a+1,b-3);
 point(a+2,b-2);
 point(a+3,b-2);
 point(a+4,b-1);
 point(a+5,b-1);
 point(a+6,b);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 point(a-6,b+6);
 point(a-5,b+6);
 point(a-4,b+5);
 point(a-3,b+5);
 point(a-2,b+4);
 point(a-1,b+4);
 point(a,b+3);
 point(a+1,b+3);
 point(a+2,b+2);
 point(a+3,b+2);
 point(a+4,b+1);
 point(a+5,b+1);
 return;
}

void __fastcall FBtSound::PaintDisabledPlayMouseNotOver() {
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-2;
 r.Bottom = Height-2;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Pen->Color = clSilver;
 register int a = Width/2+2;
 register int b = Height/2;
 point(a-5,b-4);
 point(a-5,b-3);
 point(a-5,b-2);
 point(a-5,b-1);
 point(a-5,b);
 point(a-5,b+1);
 point(a-5,b+2);
 point(a-5,b+3);
 point(a-5,b+4);
 point(a-4,b-3);
 point(a-4,b-2);
 point(a-4,b-1);
 point(a-4,b);
 point(a-4,b+1);
 point(a-4,b+2);
 point(a-4,b+3);
 point(a-3,b-3);
 point(a-3,b-2);
 point(a-3,b-1);
 point(a-3,b);
 point(a-3,b+1);
 point(a-3,b+2);
 point(a-3,b+3);
 point(a-2,b-2);
 point(a-2,b-1);
 point(a-2,b);
 point(a-2,b+1);
 point(a-2,b+2);
 point(a-1,b-2);
 point(a-1,b-1);
 point(a-1,b);
 point(a-1,b+1);
 point(a-1,b+2);
 point(a,b-1);
 point(a,b);
 point(a,b+1);
 point(a+1,b-1);
 point(a+1,b);
 point(a+1,b+1);
 point(a+2,b);
 point(a+3,b);
 point(a-6,b-5);
 point(a-6,b-4);
 point(a-6,b-3);
 point(a-6,b-2);
 point(a-6,b-1);
 point(a-6,b);
 point(a-6,b+1);
 point(a-6,b+2);
 point(a-6,b+3);
 point(a-6,b+4);
 point(a-6,b+5);
 point(a-5,b-5);
 point(a-5,b+5);
 point(a-4,b-4);
 point(a-4,b+4);
 point(a-3,b-4);
 point(a-3,b+4);
 point(a-2,b-3);
 point(a-2,b+3);
 point(a-1,b-3);
 point(a-1,b+3);
 point(a,b+2);
 point(a,b-2);
 point(a+1,b+2);
 point(a+1,b-2);
 point(a+2,b+1);
 point(a+2,b-1);
 point(a+3,b+1);
 point(a+3,b-1);
 point(a+4,b);
 point(a+5,b);
 Canvas->Pen->Color = clGray;
 point(a-7,b-6);
 point(a-7,b-5);
 point(a-7,b-4);
 point(a-7,b-3);
 point(a-7,b-2);
 point(a-7,b-1);
 point(a-7,b);
 point(a-7,b+1);
 point(a-7,b+2);
 point(a-7,b+3);
 point(a-7,b+4);
 point(a-7,b+5);
 point(a-7,b+6);
 point(a-6,b-6);
 point(a-5,b-6);
 point(a-4,b-5);
 point(a-3,b-5);
 point(a-2,b-4);
 point(a-1,b-4);
 point(a,b-3);
 point(a+1,b-3);
 point(a+2,b-2);
 point(a+3,b-2);
 point(a+4,b-1);
 point(a+5,b-1);
 point(a+6,b);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 point(a-6,b+6);
 point(a-5,b+6);
 point(a-4,b+5);
 point(a-3,b+5);
 point(a-2,b+4);
 point(a-1,b+4);
 point(a,b+3);
 point(a+1,b+3);
 point(a+2,b+2);
 point(a+3,b+2);
 point(a+4,b+1);
 point(a+5,b+1);
 Canvas->Brush->Color = clGray;
 Canvas->FrameRect(rect);
 return;
}

void __fastcall FBtSound::SetKind(TKindFBtSound k) {
 if (FKind != k) { FKind = k; }
 Repaint();
 return;
}

void __fastcall FBtSound::PaintClickedStop() {
 r.Left = 0;
 r.Top = 0;
 r.Right = Width;
 r.Bottom = Height;
 Canvas->Brush->Color = clBlack;
 Canvas->FillRect(r);
 r.Left = 1;
 r.Top = 1;
 r.Right = Width-1;
 r.Bottom = Height-1;
 Canvas->Brush->Color = clGray;
 Canvas->FillRect(r);
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-1;
 r.Bottom = Height-1;
 Canvas->Brush->Color = clSilver;
 Canvas->FillRect(r);
 b.Left = (Width/2)-6+1;
 b.Top = (Height/2)-6+1;
 b.Right = (Width/2)+6+1;
 b.Bottom = (Height/2)+6+1;
 Canvas->Brush->Color = clLime;
 Canvas->FillRect(b);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo((Width/2)+6+1,(Height/2)-6+1);
 Canvas->LineTo((Width/2)+6+1,(Height/2)+7+1);
 Canvas->MoveTo((Width/2)+6+1,(Height/2)+6+1);
 Canvas->LineTo((Width/2)-7+1,(Height/2)+6+1);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo((Width/2)-7+1,(Height/2)+6+1);
 Canvas->LineTo((Width/2)-7+1,(Height/2)-8+1);
 Canvas->MoveTo((Width/2)-6+1,(Height/2)-7+1);
 Canvas->LineTo((Width/2)+7+1,(Height/2)-7+1);
 return;
}

void __fastcall FBtSound::PaintNormalStop() {
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-2;
 r.Bottom = Height-2;
 b.Left = (Width/2)-6;
 b.Top = (Height/2)-6;
 b.Right = (Width/2)+6;
 b.Bottom = (Height/2)+6;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo(0,Height-1);
 Canvas->LineTo(0,0);
 Canvas->LineTo(Width-1,0);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 Canvas->MoveTo(1,Height-3);
 Canvas->LineTo(1,1);
 Canvas->LineTo(Width-2,1);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo(1,Height-2);
 Canvas->LineTo(Width-2,Height-2);
 Canvas->LineTo(Width-2,1);
 Canvas->Pen->Color = clBlack;
 Canvas->MoveTo(0,Height-1);
 Canvas->LineTo(Width-1,Height-1);
 Canvas->LineTo(Width-1,-1);
 Canvas->Brush->Color = c;
 Canvas->FillRect(b);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo((Width/2)+6,(Height/2)-6);
 Canvas->LineTo((Width/2)+6,(Height/2)+7);
 Canvas->MoveTo((Width/2)+6,(Height/2)+6);
 Canvas->LineTo((Width/2)-7,(Height/2)+6);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo((Width/2)-7,(Height/2)+6);
 Canvas->LineTo((Width/2)-7,(Height/2)-8);
 Canvas->MoveTo((Width/2)-6,(Height/2)-7);
 Canvas->LineTo((Width/2)+7,(Height/2)-7);
 return;
}

void __fastcall FBtSound::PaintNormalStopMouseNotOver() {
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-2;
 r.Bottom = Height-2;
 b.Left = (Width/2)-6;
 b.Top = (Height/2)-6;
 b.Right = (Width/2)+6;
 b.Bottom = (Height/2)+6;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Brush->Color = c;
 Canvas->FillRect(b);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo((Width/2)+6,(Height/2)-6);
 Canvas->LineTo((Width/2)+6,(Height/2)+7);
 Canvas->MoveTo((Width/2)+6,(Height/2)+6);
 Canvas->LineTo((Width/2)-7,(Height/2)+6);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo((Width/2)-7,(Height/2)+6);
 Canvas->LineTo((Width/2)-7,(Height/2)-8);
 Canvas->MoveTo((Width/2)-6,(Height/2)-7);
 Canvas->LineTo((Width/2)+7,(Height/2)-7);
 Canvas->Brush->Color = clGray;
 Canvas->FrameRect(rect);
 return;
}

void __fastcall FBtSound::PaintDisabledStop() {
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-2;
 r.Bottom = Height-2;
 b.Left = (Width/2)-6;
 b.Top = (Height/2)-6;
 b.Right = (Width/2)+6;
 b.Bottom = (Height/2)+6;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo(0,Height-1);
 Canvas->LineTo(0,0);
 Canvas->LineTo(Width-1,0);
 Canvas->Pen->Color = 0x00dcdcdc;  //hellgrau
 Canvas->MoveTo(1,Height-3);
 Canvas->LineTo(1,1);
 Canvas->LineTo(Width-2,1);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo(1,Height-2);
 Canvas->LineTo(Width-2,Height-2);
 Canvas->LineTo(Width-2,1);
 Canvas->Pen->Color = clBlack;
 Canvas->MoveTo(0,Height-1);
 Canvas->LineTo(Width-1,Height-1);
 Canvas->LineTo(Width-1,-1);
 Canvas->Brush->Color = clSilver;
 Canvas->FillRect(b);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo((Width/2)+6,(Height/2)-6);
 Canvas->LineTo((Width/2)+6,(Height/2)+7);
 Canvas->MoveTo((Width/2)+6,(Height/2)+6);
 Canvas->LineTo((Width/2)-7,(Height/2)+6);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo((Width/2)-7,(Height/2)+6);
 Canvas->LineTo((Width/2)-7,(Height/2)-8);
 Canvas->MoveTo((Width/2)-6,(Height/2)-7);
 Canvas->LineTo((Width/2)+7,(Height/2)-7);
 return;
}

void __fastcall FBtSound::PaintDisabledStopMouseNotOver() {
 r.Left = 2;
 r.Top = 2;
 r.Right = Width-2;
 r.Bottom = Height-2;
 b.Left = (Width/2)-6;
 b.Top = (Height/2)-6;
 b.Right = (Width/2)+6;
 b.Bottom = (Height/2)+6;
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 Canvas->FillRect(r);
 Canvas->Brush->Color = clSilver;
 Canvas->FillRect(b);
 Canvas->Pen->Color = clWhite;
 Canvas->MoveTo((Width/2)+6,(Height/2)-6);
 Canvas->LineTo((Width/2)+6,(Height/2)+7);
 Canvas->MoveTo((Width/2)+6,(Height/2)+6);
 Canvas->LineTo((Width/2)-7,(Height/2)+6);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo((Width/2)-7,(Height/2)+6);
 Canvas->LineTo((Width/2)-7,(Height/2)-8);
 Canvas->MoveTo((Width/2)-6,(Height/2)-7);
 Canvas->LineTo((Width/2)+7,(Height/2)-7);
 Canvas->Brush->Color = clGray;
 Canvas->FrameRect(rect);
 return;
}

void __fastcall FBtSound::CMMouseEnter(TMessage *Message) {
 FMouseOver = true;
 Repaint();
 return;
}

void __fastcall FBtSound::CMMouseLeave(TMessage *Message) {
 FMouseOver = false;
 Repaint();
 return;
}

void __fastcall FBtSound::MouseDown(TMouseButton Button,TShiftState Shift,int x, int y) {
 if ((Enabled) && (Button == mbLeft)) {
  clicked = true;
  Repaint();
  return;
 }
}

void __fastcall FBtSound::MouseUp(TMouseButton Button,TShiftState Shift,int x, int y) {
 if ((Enabled) && (clicked)) {
  clicked = false;
  Repaint();
  return;
 }
}

void __fastcall FBtSound::SetBounds(int l, int t, int w, int h) {
 if (w<=32) { w = 32; }
 if (h<=24) { h = 24; }
 TGraphicControl::SetBounds(l,t,w,h);
 rect.Top = 0;
 rect.Left = 0;
 rect.Bottom = Height;
 rect.Right = Width;
 return;
}
