//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include "FBtWinControl.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi-

__fastcall FBtWinControl::FBtWinControl(TComponent* Owner)
	: TCustomControl(Owner){
 Width = 16;
 Height = 14;
 r.left = 0;
 r.top = 0;
 r.bottom = Height;
 r.right = Width;
 clicked = false;
 FEnabled = true;
}

namespace Fbtwincontrol {
 void __fastcall Register() {
  TComponentClass classes[1] = {__classid(FBtWinControl)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void __fastcall FBtWinControl::Paint() {
 DC = GetDC(this->Handle);
 if (FEnabled) {
  switch(FKind) {
   case wcMinimize:
    if (clicked != true) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONMIN); return; }
    if (clicked) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONMIN | DFCS_PUSHED); return; }
   case wcClose:
    if (clicked != true) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONCLOSE); return; }
    if (clicked) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONCLOSE | DFCS_PUSHED); return; }
   case wcMaximize:
    if (clicked != true) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONMAX); return; }
    if (clicked) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONMAX | DFCS_PUSHED); return; }
   case wcHelp:
    if (clicked != true) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONHELP); return; }
    if (clicked) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONHELP | DFCS_PUSHED); return; }
   case wcNormalize:
    if (clicked != true) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONRESTORE); return; }
    if (clicked) { DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONRESTORE | DFCS_PUSHED); return; }
  }
 }
 if (!FEnabled) {
  switch(FKind) {
   case wcMinimize:
    DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONMIN | DFCS_INACTIVE); return;
   case wcClose:
    DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONCLOSE | DFCS_INACTIVE); return;
   case wcMaximize:
    DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONMAX | DFCS_INACTIVE); return;
   case wcHelp:
    DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONHELP | DFCS_INACTIVE); return;
   case wcNormalize:
    DrawFrameControl(DC,&r,DFC_CAPTION,DFCS_CAPTIONRESTORE | DFCS_INACTIVE); return;
  }
 }
}

void __fastcall FBtWinControl::SetBounds(int l, int t, int w, int h) {
 TCustomControl::SetBounds(l,t,16,14);
}

void __fastcall FBtWinControl::MouseDown(TMouseButton Button,TShiftState Shift,int x, int y) {
 if (FEnabled) {
  if (Button == mbLeft) {
   clicked = true;
   Paint();
  }
 }
}

void __fastcall FBtWinControl::MouseUp(TMouseButton Button,TShiftState Shift,int x, int y) {
 if (FEnabled) {
  if (clicked) {
   clicked = false;
   Paint();
  }
 }
}

void __fastcall FBtWinControl::SetKind(TKindFBtWinControl k) {
 FKind = k;
 Paint();
}

void __fastcall FBtWinControl::SetEnabled(Boolean b) {
 FEnabled = b;
 Paint();
}
