//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include "FDigiDisplay.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas

__fastcall FDigiDisplay::FDigiDisplay(TComponent* Owner)
	: TGraphicControl(Owner) {
 Height = 48;
 Width = 32;
 FKind = n0;
}

namespace Fdigidisplay {
 void __fastcall Register() {
  TComponentClass classes[1] = {__classid(FDigiDisplay)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void __fastcall FDigiDisplay::Paint() {
 Canvas->Brush->Color = clSilver;
 Canvas->Pen->Color = clSilver;
 TRect rect;
 rect.Top = 0;
 rect.Left = 0;
 rect.Right = 32;
 rect.Bottom = 48;
 Canvas->FillRect(rect);
 Canvas->Pen->Color = clBlack;
 Canvas->MoveTo(0,48);
 Canvas->LineTo(0,0);
 Canvas->LineTo(32,0);
 Canvas->Pen->Color = 0x00dcdcdc;
 Canvas->MoveTo(31,0);
 Canvas->LineTo(31,47);
 Canvas->LineTo(0,47);
 Canvas->Brush->Color = 0x00070707;
 Canvas->Pen->Color = 0x00070707;
 Canvas->RoundRect(2,2,30,46,6,6);
 Canvas->Pen->Color = clGreen;
 Canvas->Brush->Color = clLime;
 switch(FKind) {
  case A: PaintAs_A(); return;
  case B: PaintAs_B(); return;
  case C: PaintAs_C(); return;
  case D: PaintAs_D(); return;
  case E: PaintAs_E(); return;
  case F: PaintAs_F(); return;
  case G: PaintAs_G(); return;
  case H: PaintAs_H(); return;
  case I: PaintAs_I(); return;
  case J: PaintAs_J(); return;
  case K: PaintAs_K(); return;
  case L: PaintAs_L(); return;
  case M: PaintAs_M(); return;
  case N: PaintAs_N(); return;
  case O: PaintAs_O(); return;
  case P: PaintAs_P(); return;
  case Q: PaintAs_Q(); return;
  case R: PaintAs_R(); return;
  case S: PaintAs_S(); return;
  case T: PaintAs_T(); return;
  case U: PaintAs_U(); return;
  case V: PaintAs_V(); return;
  case W: PaintAs_W(); return;
  case X: PaintAs_X(); return;
  case Y: PaintAs_Y(); return;
  case Z: PaintAs_Z(); return;
  case aa: PaintAs_a(); return;
  case bb: PaintAs_b(); return;
  case cc: PaintAs_c(); return;
  case dd: PaintAs_d(); return;
  case ee: PaintAs_e(); return;
  case ff: PaintAs_f(); return;
  case gg: PaintAs_g(); return;
  case hh: PaintAs_h(); return;
  case ii: PaintAs_i(); return;
  case jj: PaintAs_j(); return;
  case kk: PaintAs_k(); return;
  case ll: PaintAs_l(); return;
  case mm: PaintAs_m(); return;
  case nn: PaintAs_n(); return;
  case oo: PaintAs_o(); return;
  case pp: PaintAs_p(); return;
  case qq: PaintAs_q(); return;
  case rr: PaintAs_r(); return;
  case ss: PaintAs_s(); return;
  case tt: PaintAs_t(); return;
  case uu: PaintAs_u(); return;
  case vv: PaintAs_v(); return;
  case ww: PaintAs_w(); return;
  case xx: PaintAs_x(); return;
  case yy: PaintAs_y(); return;
  case zz: PaintAs_z(); return;
  case n1: PaintAs_1(); return;
  case n2: PaintAs_2(); return;
  case n3: PaintAs_3(); return;
  case n4: PaintAs_4(); return;
  case n5: PaintAs_5(); return;
  case n6: PaintAs_6(); return;
  case n7: PaintAs_7(); return;
  case n8: PaintAs_8(); return;
  case n9: PaintAs_9(); return;
  case n0: PaintAs_0(); return;
 }
}

void __fastcall FDigiDisplay::SetKind(TKindFDigiDisplay k) {
 FKind = k;
 Repaint();
}

void FDigiDisplay::PaintAs_A() {
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint19();
 Paint20();
}

void FDigiDisplay::PaintAs_B() {
 Paint1();
 Paint3();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint17();
 Paint20();
 Paint22();
}

void FDigiDisplay::PaintAs_C() {
 Paint1();
 Paint2();
 Paint3();
 Paint6();
 Paint11();
 Paint14();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_D() {
 Paint1();
 Paint3();
 Paint6();
 Paint8();
 Paint11();
 Paint13();
 Paint14();
 Paint17();
 Paint20();
 Paint22();
}

void FDigiDisplay::PaintAs_E() {
 Paint1();
 Paint2();
 Paint3();
 Paint6();
 Paint9();
 Paint11();
 Paint14();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_F() {
 Paint1();
 Paint2();
 Paint4();
 Paint7();
 Paint9();
 Paint10();
 Paint12();
 Paint15();
}

void FDigiDisplay::PaintAs_G() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_H() {
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
}

void FDigiDisplay::PaintAs_I() {
 Paint4();
 Paint7();
 Paint12();
 Paint15();
}

void FDigiDisplay::PaintAs_J() {
 Paint5();
 Paint8();
 Paint13();
 Paint17();
 Paint22();
}

void FDigiDisplay::PaintAs_K() {
 Paint3();
 Paint5();
 Paint6();
 Paint9();
 Paint11();
 Paint14();
 Paint16();
 Paint24();
 Paint26();
}

void FDigiDisplay::PaintAs_L() {
 Paint3();
 Paint6();
 Paint11();
 Paint14();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_M() {
 Paint1();
 Paint2();
 Paint3();
 Paint4();
 Paint5();
 Paint6();
 Paint8();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
}

void FDigiDisplay::PaintAs_N() {
 Paint1();
 Paint3();
 Paint4();
 Paint5();
 Paint6();
 Paint7();
 Paint8();
 Paint11();
 Paint12();
 Paint13();
 Paint14();
 Paint15();
 Paint16();
 Paint18();
}

void FDigiDisplay::PaintAs_O() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_P() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint14();
}

void FDigiDisplay::PaintAs_Q() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
 Paint22();
}

void FDigiDisplay::PaintAs_R() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint12();
 Paint14();
 Paint15();
 Paint18();
}

void FDigiDisplay::PaintAs_S() {
 Paint2();
 Paint6();
 Paint9();
 Paint10();
 Paint13();
 Paint17();
 Paint19();
 Paint22();
}

void FDigiDisplay::PaintAs_T() {
 Paint1();
 Paint2();
 Paint3();
 Paint4();
 Paint5();
 Paint7();
 Paint12();
 Paint15();
}

void FDigiDisplay::PaintAs_U() {
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_V() {
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint11();
 Paint13();
 Paint21();
 Paint22();
}

void FDigiDisplay::PaintAs_W() {
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint11();
 Paint13();
 Paint14();
 Paint15();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_X() {
 Paint3();
 Paint5();
 Paint14();
 Paint16();
 Paint23();
 Paint24();
 Paint25();
 Paint26();
}

void FDigiDisplay::PaintAs_Y() {
 Paint3();
 Paint5();
 Paint12();
 Paint15();
 Paint23();
 Paint24();
}

void FDigiDisplay::PaintAs_Z() {
 Paint1();
 Paint2();
 Paint5();
 Paint9();
 Paint10();
 Paint14();
 Paint17();
 Paint18();
 Paint24();
 Paint25();
}

void FDigiDisplay::PaintAs_a() {
 Paint1();
 Paint2();
 Paint5();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_b() {
 Paint3();
 Paint6();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_c() {
 Paint9();
 Paint10();
 Paint11();
 Paint14();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_d() {
 Paint5();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_e() {
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint13();
 Paint16();
 Paint17();
 Paint18();
 Paint19();
 Paint20();
}

void FDigiDisplay::PaintAs_f() {
 Paint2();
 Paint6();
 Paint9();
 Paint11();
 Paint14();
 Paint19();
}

void FDigiDisplay::PaintAs_g() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint13();
 Paint17();
 Paint22();
}

void FDigiDisplay::PaintAs_h() {
 Paint3();
 Paint6();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
}

void FDigiDisplay::PaintAs_i() {
 Paint4();
 Paint12();
 Paint15();
}

void FDigiDisplay::PaintAs_j() {
 Paint4();
 Paint12();
 Paint14();
 Paint15();
 Paint17();
}

void FDigiDisplay::PaintAs_k() {
 Paint3();
 Paint6();
 Paint9();
 Paint11();
 Paint14();
 Paint16();
 Paint24();
 Paint26();
}

void FDigiDisplay::PaintAs_l() {
 Paint4();
 Paint7();
 Paint12();
 Paint15();
}

void FDigiDisplay::PaintAs_m() {
 Paint9();
 Paint10();
 Paint11();
 Paint12();
 Paint13();
 Paint14();
 Paint16();
}

void FDigiDisplay::PaintAs_n() {
 Paint9();
 Paint11();
 Paint12();
 Paint13();
 Paint14();
 Paint15();
 Paint16();
 Paint18();
}

void FDigiDisplay::PaintAs_o() {
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_p() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint14();
}

void FDigiDisplay::PaintAs_q() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint13();
 Paint16();
}

void FDigiDisplay::PaintAs_r() {
 Paint10();
 Paint12();
 Paint15();
}

void FDigiDisplay::PaintAs_s() {
 Paint14();
 Paint22();
 Paint25();
 Paint26();
}

void FDigiDisplay::PaintAs_t() {
 Paint7();
 Paint12();
 Paint15();
 Paint18();
}

void FDigiDisplay::PaintAs_u() {
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_v() {
 Paint11();
 Paint13();
 Paint21();
 Paint22();
}

void FDigiDisplay::PaintAs_w() {
 Paint11();
 Paint13();
 Paint15();
 Paint21();
 Paint22();
}

void FDigiDisplay::PaintAs_x() {
 Paint23();
 Paint24();
 Paint25();
 Paint26();
}

void FDigiDisplay::PaintAs_y() {
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint13();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_z() {
 Paint9();
 Paint14();
 Paint17();
 Paint25();
}

void FDigiDisplay::PaintAs_1() {
 Paint4();
 Paint7();
 Paint12();
 Paint15();
}

void FDigiDisplay::PaintAs_2() {
 Paint1();
 Paint2();
 Paint5();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
 Paint24();
 Paint25();
}

void FDigiDisplay::PaintAs_3() {
 Paint1();
 Paint8();
 Paint10();
 Paint13();
 Paint17();
 Paint20();
 Paint22();
}

void FDigiDisplay::PaintAs_4() {
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint13();
 Paint16();
}

void FDigiDisplay::PaintAs_5() {
 Paint1();
 Paint2();
 Paint3();
 Paint6();
 Paint9();
 Paint10();
 Paint13();
 Paint17();
 Paint22();
}

void FDigiDisplay::PaintAs_6() {
 Paint1();
 Paint2();
 Paint3();
 Paint6();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint17();
 Paint22();
}

void FDigiDisplay::PaintAs_7() {
 Paint1();
 Paint2();
 Paint5();
 Paint8();
 Paint13();
 Paint16();
}

void FDigiDisplay::PaintAs_8() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_9() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint9();
 Paint10();
 Paint13();
 Paint15();
 Paint16();
 Paint17();
 Paint18();
}

void FDigiDisplay::PaintAs_0() {
 Paint1();
 Paint2();
 Paint3();
 Paint5();
 Paint6();
 Paint8();
 Paint11();
 Paint13();
 Paint14();
 Paint16();
 Paint17();
 Paint18();
}

void __fastcall FDigiDisplay::SetBounds(int l, int t, int w, int h) {
 TGraphicControl::SetBounds(l,t,32,48);
}

void FDigiDisplay::Paint1() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 7;
 p1.y = 6;
 p2.x = 8;
 p2.y = 5;
 p3.x = 14;
 p3.y = 5;
 p4.x = 15;
 p4.y = 6;
 p5.x = 14;
 p5.y = 7;
 p6.x = 8;
 p6.y = 7;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint2() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x =  17;
 p1.y =  6;
 p2.x =  18;
 p2.y =  5;
 p3.x =  24;
 p3.y =  5;
 p4.x =  25;
 p4.y =  6;
 p5.x =  24;
 p5.y =  7;
 p6.x =  18;
 p6.y =  7;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint3() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 6;
 p1.y = 7;
 p2.x = 7;
 p2.y = 8;
 p3.x = 7;
 p3.y = 13;
 p4.x = 6;
 p4.y = 14;
 p5.x = 5;
 p5.y = 13;
 p6.x = 5;
 p6.y = 8;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint4() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 16;
 p1.y = 7;
 p2.x = 17;
 p2.y = 8;
 p3.x = 17;
 p3.y = 13;
 p4.x = 16;
 p4.y = 14;
 p5.x = 15;
 p5.y = 13;
 p6.x = 15;
 p6.y = 8;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint5() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 26;
 p1.y = 7;
 p2.x = 27;
 p2.y = 8;
 p3.x = 27;
 p3.y = 13;
 p4.x = 26;
 p4.y = 14;
 p5.x = 25;
 p5.y = 13;
 p6.x = 25;
 p6.y = 8;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint6() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 6;
 p1.y = 16;
 p2.x = 7;
 p2.y = 17;
 p3.x = 7;
 p3.y = 22;
 p4.x = 6;
 p4.y = 23;
 p5.x = 5;
 p5.y = 22;
 p6.x = 5;
 p6.y = 17;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint7() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 16;
 p1.y = 16;
 p2.x = 17;
 p2.y = 17;
 p3.x = 17;
 p3.y = 22;
 p4.x = 16;
 p4.y = 23;
 p5.x = 15;
 p5.y = 22;
 p6.x = 15;
 p6.y = 17;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint8() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 26;
 p1.y = 16;
 p2.x = 27;
 p2.y = 17;
 p3.x = 27;
 p3.y = 22;
 p4.x = 26;
 p4.y = 23;
 p5.x = 25;
 p5.y = 22;
 p6.x = 25;
 p6.y = 17;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint9() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 7;
 p1.y = 24;
 p2.x = 8;
 p2.y = 23;
 p3.x = 14;
 p3.y = 23;
 p4.x = 15;
 p4.y = 24;
 p5.x = 14;
 p5.y = 25;
 p6.x = 8;
 p6.y = 25;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint10() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 17;
 p1.y = 24;
 p2.x = 18;
 p2.y = 23;
 p3.x = 24;
 p3.y = 23;
 p4.x = 25;
 p4.y = 24;
 p5.x = 24;
 p5.y = 25;
 p6.x = 18;
 p6.y = 25;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint11() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 6;
 p1.y = 25;
 p2.x = 7;
 p2.y = 26;
 p3.x = 7;
 p3.y = 31;
 p4.x = 6;
 p4.y = 32;
 p5.x = 5;
 p5.y = 31;
 p6.x = 5;
 p6.y = 26;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint12() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 16;
 p1.y = 25;
 p2.x = 17;
 p2.y = 26;
 p3.x = 17;
 p3.y = 31;
 p4.x = 16;
 p4.y = 32;
 p5.x = 15;
 p5.y = 31;
 p6.x = 15;
 p6.y = 26;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint13() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 26;
 p1.y = 25;
 p2.x = 27;
 p2.y = 26;
 p3.x = 27;
 p3.y = 31;
 p4.x = 26;
 p4.y = 32;
 p5.x = 25;
 p5.y = 31;
 p6.x = 25;
 p6.y = 26;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint14() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 6;
 p1.y = 34;
 p2.x = 7;
 p2.y = 35;
 p3.x = 7;
 p3.y = 40;
 p4.x = 6;
 p4.y = 41;
 p5.x = 5;
 p5.y = 40;
 p6.x = 5;
 p6.y = 35;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint15() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 16;
 p1.y = 34;
 p2.x = 17;
 p2.y = 35;
 p3.x = 17;
 p3.y = 40;
 p4.x = 16;
 p4.y = 41;
 p5.x = 15;
 p5.y = 40;
 p6.x = 15;
 p6.y = 35;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint16() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 26;
 p1.y = 34;
 p2.x = 27;
 p2.y = 35;
 p3.x = 27;
 p3.y = 40;
 p4.x = 26;
 p4.y = 41;
 p5.x = 25;
 p5.y = 40;
 p6.x = 25;
 p6.y = 35;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint17() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 7;
 p1.y = 42;
 p2.x = 8;
 p2.y = 41;
 p3.x = 13;
 p3.y = 41;
 p4.x = 14;
 p4.y = 42;
 p5.x = 13;
 p5.y = 43;
 p6.x = 8;
 p6.y = 43;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint18() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 17;
 p1.y = 42;
 p2.x = 18;
 p2.y = 41;
 p3.x = 23;
 p3.y = 41;
 p4.x = 24;
 p4.y = 42;
 p5.x = 23;
 p5.y = 43;
 p6.x = 18;
 p6.y = 43;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint19() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 7;
 p1.y = 16;
 p2.x = 7;
 p2.y = 15;
 p3.x = 14;
 p3.y = 8;
 p4.x = 15;
 p4.y = 8;
 p5.x = 15;
 p5.y = 9;
 p6.x = 8;
 p6.y = 16;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint20() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 25;
 p1.y = 16;
 p2.x = 24;
 p2.y = 16;
 p3.x = 17;
 p3.y = 9;
 p4.x = 17;
 p4.y = 8;
 p5.x = 18;
 p5.y = 8;
 p6.x = 25;
 p6.y = 15;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint21() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 7;
 p1.y = 32;
 p2.x = 8;
 p2.y = 32;
 p3.x = 15;
 p3.y = 39;
 p4.x = 15;
 p4.y = 40;
 p5.x = 14;
 p5.y = 40;
 p6.x = 7;
 p6.y = 33;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint22() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 25;
 p1.y = 32;
 p2.x = 25;
 p2.y = 33;
 p3.x = 18;
 p3.y = 40;
 p4.x = 17;
 p4.y = 40;
 p5.x = 17;
 p5.y = 39;
 p6.x = 24;
 p6.y = 32;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint23() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 7;
 p1.y = 14;
 p2.x = 8;
 p2.y = 14;
 p3.x = 15;
 p3.y = 21;
 p4.x = 15;
 p4.y = 22;
 p5.x = 14;
 p5.y = 22;
 p6.x = 7;
 p6.y = 15;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint24() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 25;
 p1.y = 14;
 p2.x = 25;
 p2.y = 15;
 p3.x = 18;
 p3.y = 22;
 p4.x = 17;
 p4.y = 22;
 p5.x = 17;
 p5.y = 21;
 p6.x = 24;
 p6.y = 14;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint25() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 7;
 p1.y = 34;
 p2.x = 7;
 p2.y = 33;
 p3.x = 14;
 p3.y = 26;
 p4.x = 15;
 p4.y = 26;
 p5.x = 15;
 p5.y = 27;
 p6.x = 8;
 p6.y = 34;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}

void FDigiDisplay::Paint26() {
 TPoint p1;
 TPoint p2;
 TPoint p3;
 TPoint p4;
 TPoint p5;
 TPoint p6;
 TPoint points[6];
 p1.x = 25;
 p1.y = 34;
 p2.x = 24;
 p2.y = 34;
 p3.x = 17;
 p3.y = 27;
 p4.x = 17;
 p4.y = 26;
 p5.x = 18;
 p5.y = 26;
 p6.x = 25;
 p6.y = 33;
 points[0] = p1;
 points[1] = p2;
 points[2] = p3;
 points[3] = p4;
 points[4] = p5;
 points[5] = p6;
 points[6] = p1;
 Canvas->Polygon(points,6);
}
