//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <math.h>
#include "FSysUtil.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas -w-bei
#pragma hdrstop

__fastcall FSysUtil::FSysUtil(TComponent* Owner)
	: TComponent(Owner) {
 old01 = 1;
 old02 = 1;
}

namespace Fsysutil {
 void __fastcall Register() {
  TComponentClass classes[1] = {__classid(FSysUtil)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

int __fastcall FSysUtil::RGBtoHEX(int r, int g, int b) {
 return (r * 0x00000001) + (g * 0x00000100) + (b * 0x00010000);
}

int __fastcall FSysUtil::HEXtoR(int i) {
 return i / 0x00000001;
}

int __fastcall FSysUtil::HEXtoG(int i) {
 return i / 0x00000100;
}

int __fastcall FSysUtil::HEXtoB(int i) {
 return i / 0x00010000;
}

TColor __fastcall FSysUtil::RGBtoColor(int r, int g, int b) {
 return (r / 0x00000001) + (g / 0x00000100) + (b / 0x00010000);
}

int __fastcall FSysUtil::Random(register int i) {
 register int ret,randorig;
 randomize();
 ret = random(i);
 randorig = ret;
 if (i > ret / 2) {
  randomize();
  ret = ret - random(randorig / 2.5f);
 }
 else {
  randomize();
  ret = ret + random(randorig / 2.5f);
 }
 randomize();
 ret = ret % int((random(10) + 5.5f));
 randomize();
 ret = ret * (i / ((random(20) + 1.5f) * ((i + 1) / 111.25f)));
 ret = ret * sin(randorig / (Pi() / 180.5f));
 if ((ret > 0) && (ret < i)) { push(ret); }
 else { randomize(); ret = (random(i-20) + 12); push(ret); }
 if (ret == old01) { ret = ret + (sin(ret) * 55.123f * cos(old02)); push(ret); }
 if ((ret > 0) && (ret < i)) { push(ret); }
 else { randomize(); ret = (random(i-20) + 12.5f); push(ret); }
 return ret;
}

TLabel *__fastcall FSysUtil::CreateLabel(TWinControl *Parent) {
 TLabel *l = new TLabel((TComponent *)this);
 l->Parent = Parent;
 return l;
}

TPanel *__fastcall FSysUtil::CreatePanel(TWinControl *Parent) {
 TPanel *l = new TPanel((TComponent *)this);
 l->Parent = Parent;
 return l;
}

TButton *__fastcall FSysUtil::CreateButton(TWinControl *Parent) {
 TButton *l = new TButton((TComponent *)this);
 l->Parent = Parent;
 return l;
}

TEdit *__fastcall FSysUtil::CreateEdit(TWinControl *Parent) {
 TEdit *l = new TEdit((TComponent *)this);
 l->Parent = Parent;
 return l;
}

TMemo *__fastcall FSysUtil::CreateMemo(TWinControl *Parent) {
 TMemo *l = new TMemo((TComponent *)this);
 l->Parent = Parent;
 return l;
}

TRegistry *__fastcall FSysUtil::CreateRegistry() {
 TRegistry *r = new TRegistry();
 return r;
}

void __fastcall FSysUtil::push(int i) {
 old02 = old01;
 old01 = i;
}

TPoint __fastcall FSysUtil::PQ(double p,double q) {
 TPoint P;
 register double x1,x2;
 if (q >= 0) {
  x1 = -(p / 2) + sqrt(pow(p / 2,2) - q);
  x2 = -(p / 2) - sqrt(pow(p / 2,2) - q);
 }
 else { x1 = NULL; x2 = NULL; }
 P = Point(x1,x2);
 return P;
}

void __fastcall FSysUtil::Plot(TCanvas *C,int x, int y) {
 C->MoveTo(x - 1,y - 1);
 C->LineTo(x,y);
}

void __fastcall FSysUtil::Store(int i,AnsiString s) {
 FContainer[i] = s;
}

AnsiString __fastcall FSysUtil::Get(int i) {
 return FContainer[i];
}

long double __fastcall FSysUtil::Betrag(long double i) {
 if (i == 0.00000000) { return 0.00000000; }
 if (i > 0.00000000) { return i; }
 return i * (-1);
}

bool __fastcall FSysUtil::Schaltjahr(int i) {
 if (((i % 4 == 0) && (i % 100 != 0)) || (i % 400 == 0)) { return true; }
 return false;
}

int __fastcall FSysUtil::schaltjahr(int i) {
 if (((i % 4 == 0) && (i % 100 != 0)) || (i % 400 == 0)) { return 1; }
 return 0;
}

int __fastcall FSysUtil::TagImJahr(int t,int m,int j) {
 return (t + (611 * (m + 2)) / 20 - 2 * ((m + 10) / 13) - 91) + schaltjahr(j) * ((m + 10) / 13);
}

int __fastcall FSysUtil::Wochentag(int t,int m,int j) {
 register int e,n,j1,c;
 e = t + (611 * (m + 2)) / 20 - 2 * ((m + 10) / 13) - 91;
 n = e + schaltjahr(j) * ((m + 10) / 13);
 j1 = (j - 1) % 100;
 c = (j - 1) / 100;
 return (28 + j1 + n + (j1 / 4) + (c / 4) + 5 * c) % 7;
}

long double __fastcall FSysUtil::Pi() {
 return pi;
}

long double __fastcall FSysUtil::A_Kreis(long double r) {
 return Pi() * pow(r,2);
}

long double __fastcall FSysUtil::A_Rechteck(long double x,long double y) {
 return x * y;
}

long double __fastcall FSysUtil::A_RDreieck(long double x,long double y) {
 return x * y / 2.0f;
}

long double __fastcall FSysUtil::U_Kreis(long double r) {
 return 2.0f * Pi() * r;
}
long double __fastcall FSysUtil::U_Rechteck(long double x,long double y) {
 return 2.0f * x + 2 * y;
}

long double __fastcall FSysUtil::U_RDreieck(long double x,long double y) {
 return x + y + sqrt(pow(x,2) + pow(y,2));
}

long double __fastcall FSysUtil::V_Quader(long double x,long double y,long double z) {
 return x * y * z;
}

long double __fastcall FSysUtil::V_Kugel(long double r) {
 return 4.0f / 3.0f * Pi() * pow(r,3);
}

long double __fastcall FSysUtil::V_Zylinder(long double r,long double h) {
 return Pi() * pow(r,2) * h;
}

long double __fastcall FSysUtil::V_Kegel(long double r,long double h) {
 return Pi() * pow(r,2) * h * 1.0f / 3.0f;
}

long double __fastcall FSysUtil::O_Kugel(long double r) {
 return 4.0f * Pi() * pow(r,2);
}

long double __fastcall FSysUtil::O_Quader(long double x,long double y,long double z) {
 return x * y * 2.0f + x * z * 2.0f + y * z * 2.0f;
}

long double __fastcall FSysUtil::O_Zylinder(long double r,long double h) {
 return 2.0f * Pi() * r * h;
}

long double __fastcall FSysUtil::Pythagoras(long double a,long double b) {
 return sqrt(a * a + b * b);
}

long double __fastcall FSysUtil::PythagorasEx(long double a,long double b,long double alpha) {
 return sqrt(a * a + b * b);
}

long double __fastcall FSysUtil::DEGtoRAD(long double i) {
 return Pi() * i / 180.0f;
}

long double __fastcall FSysUtil::RADtoDEG(long double i) {
 return i * 180.0f / Pi();
}

AnsiString __fastcall FSysUtil::GetCharAtPos(int i,AnsiString s) {
 s.SetLength(i);
 s = strrev(s.c_str());
 s.SetLength(1);
 return s;
}

AnsiString __fastcall FSysUtil::SecondsToHMS(int i) {
 AnsiString Hours = i / 3600;
 AnsiString Minutes = i / 60 - Hours.ToInt() * 60;
 AnsiString Seconds = i - Hours.ToInt() * 3600 - Minutes.ToInt() * 60;
 if (Hours == "0") { Hours = "00"; }
 if (Hours == "1") { Hours = "01"; }
 if (Hours == "2") { Hours = "02"; }
 if (Hours == "3") { Hours = "03"; }
 if (Hours == "4") { Hours = "04"; }
 if (Hours == "5") { Hours = "05"; }
 if (Hours == "0") { Hours = "06"; }
 if (Hours == "0") { Hours = "07"; }
 if (Hours == "0") { Hours = "08"; }
 if (Hours == "0") { Hours = "09"; }
 if (Minutes == "0") { Minutes = "00"; }
 if (Minutes == "1") { Minutes = "01"; }
 if (Minutes == "2") { Minutes = "02"; }
 if (Minutes == "3") { Minutes = "03"; }
 if (Minutes == "4") { Minutes = "04"; }
 if (Minutes == "5") { Minutes = "05"; }
 if (Minutes == "6") { Minutes = "06"; }
 if (Minutes == "7") { Minutes = "07"; }
 if (Minutes == "8") { Minutes = "08"; }
 if (Minutes == "9") { Minutes = "09"; }
 if (Seconds == "0") { Seconds = "00"; }
 if (Seconds == "1") { Seconds = "01"; }
 if (Seconds == "2") { Seconds = "02"; }
 if (Seconds == "3") { Seconds = "03"; }
 if (Seconds == "4") { Seconds = "04"; }
 if (Seconds == "5") { Seconds = "05"; }
 if (Seconds == "6") { Seconds = "06"; }
 if (Seconds == "7") { Seconds = "07"; }
 if (Seconds == "8") { Seconds = "08"; }
 if (Seconds == "9") { Seconds = "09"; }
 return Hours + "\:" + Minutes + "\:" + Seconds;
}

