//             (C) by Florian Lindner 1998
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <mmsystem.h>
#include "FVolumeControl.h"
#include "ShortCuts.h"
#pragma resource "FComponents.res"
#pragma hdrstop
#pragma option -5 -O2 -OS -d- -fp -O -Oi -Ov -vi- -w-eas

__fastcall FVolumeControl::FVolumeControl(TComponent* Owner)
	: TGraphicControl(Owner) {
 for (register int i = 0; i < 16; i++) { DeviceNames[i] = ""; }
 MouseOver = false;
 FCaption = "Volume Control";
 FormPos = Point(0,0);
 LayerForm = new TForm((TComponent *)this);
 LayerForm->BorderStyle = bsNone;
 LayerForm->OnDeactivate = OnLooseFocus;
 LayerForm->OnPaint = OnLayerFormPaint;
 LayerForm->SetBounds(0,0,512,180);
 LayerForm->Color = clBlack;
 Canvas->Pen->Color = clBlack;
 Canvas->Brush->Color = clBlack;
 Canvas->Font->Size = 8;
 Canvas->Font->Name = "Times New Roman";
 Canvas->Brush->Style = bsClear;
 Canvas->Font->Style = Canvas->Font->Style << fsBold;
 NumberOfDevices = auxGetNumDevs();
 if ((NumberOfDevices > 16) && (NumberOfDevices >= 1)) { MessageBox(NULL,"More than 16 Devices not supported!","",MB_OK); }
 Slider01 = CreateSlider(); Label01 = CreateHorzLabel();
 Slider02 = CreateSlider(); Label02 = CreateHorzLabel();
 Slider03 = CreateSlider(); Label03 = CreateHorzLabel();
 Slider04 = CreateSlider(); Label04 = CreateHorzLabel();
 Slider05 = CreateSlider(); Label05 = CreateHorzLabel();
 Slider06 = CreateSlider(); Label06 = CreateHorzLabel();
 Slider07 = CreateSlider(); Label07 = CreateHorzLabel();
 Slider08 = CreateSlider(); Label08 = CreateHorzLabel();
 Slider09 = CreateSlider(); Label09 = CreateHorzLabel();
 Slider10 = CreateSlider(); Label10 = CreateHorzLabel();
 Slider11 = CreateSlider(); Label11 = CreateHorzLabel();
 Slider12 = CreateSlider(); Label12 = CreateHorzLabel();
 Slider13 = CreateSlider(); Label13 = CreateHorzLabel();
 Slider14 = CreateSlider(); Label14 = CreateHorzLabel();
 Slider15 = CreateSlider(); Label15 = CreateHorzLabel();
 Slider16 = CreateSlider(); Label16 = CreateHorzLabel();
 BtClose = new FCustomButton((TComponent *)this);
 BtClose->Parent = (TWinControl *)LayerForm;
 BtClose->SetBounds(NumberOfDevices * 64 - 48,16,32,16);
 BtClose->OnClick = OnBtCloseClick;
 Slider01->SetBounds(4,48,48,128);
 Slider02->SetBounds((64 * 1) + 4,48,48,128);
 Slider03->SetBounds((64 * 2) + 4,48,48,128);
 Slider04->SetBounds((64 * 3) + 4,48,48,128);
 Slider05->SetBounds((64 * 4) + 4,48,48,128);
 Slider06->SetBounds((64 * 5) + 4,48,48,128);
 Slider07->SetBounds((64 * 6) + 4,48,48,128);
 Slider08->SetBounds((64 * 7) + 4,48,48,128);
 Slider09->SetBounds((64 * 8) + 4,48,48,128);
 Slider10->SetBounds((64 * 9) + 4,48,48,128);
 Slider11->SetBounds((64 * 10) + 4,48,48,128);
 Slider12->SetBounds((64 * 11) + 4,48,48,128);
 Slider13->SetBounds((64 * 12) + 4,48,48,128);
 Slider14->SetBounds((64 * 13) + 4,48,48,128);
 Slider15->SetBounds((64 * 14) + 4,48,48,128);
 Slider16->SetBounds((64 * 15) + 4,48,48,128);
 Slider01->DeviceID = 0;
 Slider02->DeviceID = 1;
 Slider03->DeviceID = 2;
 Slider04->DeviceID = 3;
 Slider05->DeviceID = 4;
 Slider06->DeviceID = 5;
 Slider07->DeviceID = 6;
 Slider08->DeviceID = 7;
 Slider09->DeviceID = 8;
 Slider10->DeviceID = 9;
 Slider11->DeviceID = 10;
 Slider12->DeviceID = 11;
 Slider13->DeviceID = 12;
 Slider14->DeviceID = 13;
 Slider15->DeviceID = 14;
 Slider16->DeviceID = 15;
 Label01->SetBounds(54,40,8,128);
 Label02->SetBounds((64 * 1) + 54,40,10,128);
 Label03->SetBounds((64 * 2) + 54,40,10,128);
 Label04->SetBounds((64 * 3) + 54,40,10,128);
 Label05->SetBounds((64 * 4) + 54,40,10,128);
 Label06->SetBounds((64 * 5) + 54,40,10,128);
 Label07->SetBounds((64 * 6) + 54,40,10,128);
 Label08->SetBounds((64 * 7) + 54,40,10,128);
 Label09->SetBounds((64 * 8) + 54,40,10,128);
 Label10->SetBounds((64 * 9) + 54,40,10,128);
 Label11->SetBounds((64 * 10) + 54,40,10,128);
 Label12->SetBounds((64 * 11) + 54,40,10,128);
 Label13->SetBounds((64 * 12) + 54,40,10,128);
 Label14->SetBounds((64 * 13) + 54,40,10,128);
 Label15->SetBounds((64 * 14) + 54,40,10,128);
 Label16->SetBounds((64 * 15) + 54,40,10,128);
 CaptionLabel = new FShadowLabel((TComponent *)this);
 CaptionLabel->Parent = (TWinControl *)LayerForm;
 CaptionLabel->SetBounds(16,8,NumberOfDevices * 64 - 96,32);
 GetDeviceInfos();
 Label01->Caption = DeviceNames[0];
 Label02->Caption = DeviceNames[1];
 Label03->Caption = DeviceNames[2];
 Label04->Caption = DeviceNames[3];
 Label05->Caption = DeviceNames[4];
 Label06->Caption = DeviceNames[5];
 Label07->Caption = DeviceNames[6];
 Label08->Caption = DeviceNames[7];
 Label09->Caption = DeviceNames[8];
 Label10->Caption = DeviceNames[9];
 Label11->Caption = DeviceNames[10];
 Label12->Caption = DeviceNames[11];
 Label13->Caption = DeviceNames[12];
 Label14->Caption = DeviceNames[13];
 Label15->Caption = DeviceNames[14];
 Label16->Caption = DeviceNames[15];
 GetVolumeInfos();
}

namespace Fvolumecontrol {
 void __fastcall Register() {
  TComponentClass classes[1] = {__classid(FVolumeControl)};
  RegisterComponents("FLoh!", classes, 0);
 }
}

void __fastcall FVolumeControl::SetBounds(int l,int t,int w,int h) {
 TGraphicControl::SetBounds(l,t,20,196);
 FormPos = Point(l + 8,t + 8);
 if (this->Parent != NULL) { FormPos = ClientToScreen(FormPos); }
 if (LayerForm != NULL) { LayerForm->SetBounds(FormPos.x,FormPos.y,512,180);}
 r1.Left = 2;
 r1.Top = 2;
 r1.Bottom = Height;
 r1.Right = 20;
 r2.Left = 0;
 r2.Top = 0;
 r2.Bottom = Height - 2;
 r2.Right = 18;
 r3.Left = 1;
 r3.Top = 1;
 r3.Bottom = Height - 1;
 r3.Right = 19;
}

void __fastcall FVolumeControl::Paint() {
 switch(MouseOver) {
  case true:
   Canvas->Pen->Color = clGray;
   Canvas->Brush->Color = clGray;
   Canvas->FillRect(r1);
   Canvas->Pen->Color = clWhite;
   Canvas->Brush->Color = clWhite;
   Canvas->FillRect(r2);
   Canvas->Pen->Color = clSilver;
   Canvas->Brush->Color = clSilver;
   Canvas->FillRect(r3);
  case false:
   Canvas->Pen->Color = clGray;
   Canvas->Brush->Color = clSilver;
   Canvas->FillRect(r3);
   Canvas->FrameRect(r3);
 }
 for (unsigned register int i = 1; i <= strlen(Caption.c_str()); i++) {
  Canvas->Brush->Style = bsClear;
  Canvas->Font->Color = clGray;
  Canvas->TextOut(10-(Canvas->TextWidth(GetCharAtPos(i,Caption))/2) + 1,i*13-3,GetCharAtPos(i,Caption));
  Canvas->Font->Color = clBlack;
  Canvas->TextOut(10-(Canvas->TextWidth(GetCharAtPos(i,Caption))/2),i*13-4,GetCharAtPos(i,Caption));
 }
}

void __fastcall FVolumeControl::CMMouseEnter(TMessage *) {
 MouseOver = true;
 Repaint();
}

void __fastcall FVolumeControl::CMMouseLeave(TMessage *) {
 MouseOver = false;
 Repaint();
}

void __fastcall FVolumeControl::MouseDown(TMouseButton,TShiftState,int,int) {
 LayerForm->Hide();
 for (register int i = 0; i < LayerForm->ControlCount; i++) {
  LayerForm->Controls[i]->Hide();
 }
 FormPos = Point(8,8);
 FormPos = ClientToScreen(FormPos);
 LayerForm->SetBounds(FormPos.x,FormPos.y,0,180);
 LayerForm->Width = 0;
 LayerForm->Show();
 if (NumberOfDevices != 0) {
  for (register int i = 0; i < (NumberOfDevices * 64) + 5; i++) {
   LayerForm->Width = i;
   LayerForm->Update();
  }
 }
 LayerForm->Canvas->Pen->Color = clWhite;
 LayerForm->Canvas->Brush->Color = clWhite;
 LayerForm->Canvas->MoveTo(0,180);
 LayerForm->Canvas->LineTo(0,0);
 LayerForm->Canvas->LineTo(LayerForm->Width - 1,0);
 for (register int i = 0; i < LayerForm->ControlCount; i++) {
  LayerForm->Controls[i]->Show();
 }
}

AnsiString __fastcall FVolumeControl::GetCharAtPos(int i,AnsiString s) {
 s.SetLength(i);
 s = strrev(s.c_str());
 s.SetLength(1);
 return s;
}

void __fastcall FVolumeControl::SetCaption(AnsiString s) {
 if (FCaption != s) { FCaption = s; CaptionLabel->Caption = s; Repaint(); }
}

void __fastcall FVolumeControl::OnLooseFocus(TObject *) {
 LayerForm->Hide();
}

void __fastcall FVolumeControl::OnBtCloseClick(TObject *) {
 LayerForm->Hide();
}

void __fastcall FVolumeControl::OnLayerFormPaint(TObject *) {
 LayerForm->Canvas->Pen->Color = clWhite;
 LayerForm->Canvas->Brush->Color = clWhite;
 LayerForm->Canvas->MoveTo(0,180);
 LayerForm->Canvas->LineTo(0,0);
 LayerForm->Canvas->LineTo(LayerForm->Width - 1,0);
}

FVolumeControl::FSlider *__fastcall FVolumeControl::CreateSlider() {
 FSlider *s = new FSlider((TComponent *)this);
 s->Parent = (TWinControl *)LayerForm;
 s->SetBounds(0,0,0,0);
 return s;
}

FVolumeControl::FHorzLabel *__fastcall FVolumeControl::CreateHorzLabel() {
 FHorzLabel *h = new FHorzLabel((TComponent *)this);
 h->Parent = (TWinControl *)LayerForm;
 h->SetBounds(0,0,0,0);
 return h;
}

void __fastcall FVolumeControl::GetDeviceInfos() {
 AUXCAPS AuxCaps;
 for (register int i = 0; i < NumberOfDevices; i++) {
  auxGetDevCaps(i,&AuxCaps,sizeof(AuxCaps));
  AnsiString a = AuxCaps.szPname;
  AnsiString tmp = strpbrk(a.c_str(),"\:");
  tmp = strrev(tmp.c_str());
  tmp.SetLength(tmp.Length() - 1);
  tmp = strrev(tmp.c_str());
  DeviceNames[i] = tmp.c_str();
 }
}

void __fastcall FVolumeControl::GetVolumeInfos() {
 for (register int i = 0; i < NumberOfDevices; i++) {
  DWORD rul;
  auxGetVolume(i,&rul);
  double d = 65535 - LOWORD(rul);
  d = d / 65536;
  d = d * 116;
  Volumes[i] = d;
 }
 Slider01->Position = Volumes[0];
 Slider02->Position = Volumes[1];
 Slider03->Position = Volumes[2];
 Slider04->Position = Volumes[3];
 Slider05->Position = Volumes[4];
 Slider06->Position = Volumes[5];
 Slider07->Position = Volumes[6];
 Slider08->Position = Volumes[7];
 Slider09->Position = Volumes[8];
 Slider10->Position = Volumes[9];
 Slider11->Position = Volumes[10];
 Slider12->Position = Volumes[11];
 Slider13->Position = Volumes[12];
 Slider14->Position = Volumes[13];
 Slider15->Position = Volumes[14];
 Slider16->Position = Volumes[15];
}

// ------------- FSlider -------------------------------------------------------

__fastcall FVolumeControl::FSlider::FSlider(TComponent *Owner)
	: TCustomControl(Owner) {
 FPosition = 0;
 rect.Left = 0;
 rect.Top = 0;
 rect.Bottom = 128;
 rect.Right = 48;
 Mover = new FMover((TComponent *)this);
 Mover->Parent = (TWinControl *)this;
 Mover->SetBounds(16,4,16,8);
 DeviceID = 0;
}

void __fastcall FVolumeControl::FSlider::Paint() {
 Canvas->Pen->Color = clSilver;
 Canvas->Brush->Color = clSilver;
 Canvas->FillRect(rect);
 Canvas->Pen->Color = clGray;
 Canvas->MoveTo(w2 - 2,Height - 6);
 Canvas->LineTo(w2 - 2,6);
 Canvas->LineTo(w2 + 1,6);
 Canvas->Pen->Color = clWhite;
 Canvas->LineTo(w2 + 1,Height - 6);
 Canvas->LineTo(w2 - 2,Height - 6);
}

void __fastcall FVolumeControl::FSlider::SetPosition(int i) {
 FPosition = i;
 Mover->Top = i;
 Repaint();
}

void __fastcall FVolumeControl::FSlider::MouseDown(TMouseButton mb,TShiftState,int,int y) {
 if (mb == mbLeft) {
  MouseD = true;
  if ((y > 4) && (y < 120)) { Mover->Top = y - 2; SetVolume(116 - Mover->Top - 2); MouseD = false; Repaint(); }
  if (y <= 4) { Mover->Top = 2; SetVolume(116 - Mover->Top - 2); Repaint(); MouseD = false; }
  if (y >= 120) { Mover->Top = 118; SetVolume(116 - Mover->Top - 2); Repaint(); MouseD = false; }
 }
}

void inline __fastcall FVolumeControl::FSlider::SetVolume(int i) {
 float i2 = i;
 float tmp = (i2 / 116.0f);
 tmp = tmp * 65535;
 DWORD Vol = (LOWORD(tmp) << 16) + LOWORD(tmp);
 auxSetVolume(DeviceID,Vol);
}

void __fastcall FVolumeControl::FSlider::MouseUp(TMouseButton mb,TShiftState,int,int y) {
 MouseD = false; Repaint();
}

void __fastcall FVolumeControl::FSlider::MouseMove(TShiftState,int,int y) {
 if (MouseD) {
  if ((y > 4) && (y < 120)) { Mover->Top = y - 2; SetVolume(116 - Mover->Top - 2); MouseD = false; Repaint(); }
  if (y <= 4) { Mover->Top = 2; SetVolume(116 - Mover->Top - 2); Repaint(); MouseD = false; }
  if (y >= 120) { Mover->Top = 118; SetVolume(116 - Mover->Top - 2); Repaint(); MouseD = false; }
 }
}

void __fastcall FVolumeControl::FSlider::CMMouseEnter(TMessage *) {
 Canvas->MoveTo(0,Height);
 Canvas->Pen->Color = clGray;
 Canvas->LineTo(0,0);
 Canvas->LineTo(Width - 1,0);
 Canvas->Pen->Color = clWhite;
 Canvas->LineTo(Width - 1,Height - 1);
 Canvas->LineTo(0,Height - 1);
}

void __fastcall FVolumeControl::FSlider::CMMouseLeave(TMessage *) {
 Canvas->MoveTo(0,Height);
 Canvas->Pen->Color = clSilver;
 Canvas->LineTo(0,0);
 Canvas->LineTo(Width - 1,0);
 Canvas->LineTo(Width - 1,Height - 1);
 Canvas->LineTo(0,Height - 1);
}

// ------------- FHorzLabel ----------------------------------------------------

__fastcall FVolumeControl::FHorzLabel::FHorzLabel(TComponent *Owner)
	: TGraphicControl(Owner) {
 FCaption = "Label";
 Canvas->Pen->Color = clBlack;
 Canvas->Brush->Color = clBlack;
 Canvas->Font->Size = 6;
 Canvas->Font->Color = clWhite;
 Canvas->Font->Name = "MS Sans Serif";
 Canvas->Brush->Style = bsClear;
 Hint = Caption;
 ShowHint = true;
}

void __fastcall FVolumeControl::FHorzLabel::CMMouseEnter(TMessage *) {
 Canvas->Font->Style = Canvas->Font->Style << fsBold;
 Repaint();
}

void __fastcall FVolumeControl::FHorzLabel::CMMouseLeave(TMessage *) {
Canvas->Font->Style = Canvas->Font->Style >> fsBold;
Repaint();
}

void __fastcall FVolumeControl::FHorzLabel::SetCaption(AnsiString s) {
 if (FCaption != s) { FCaption = s; Repaint(); }
}

void __fastcall FVolumeControl::FHorzLabel::Paint() {
 Hint = Caption;
 ShowHint = true;
 for (unsigned register int i = 1; i <= strlen(Caption.c_str()); i++) {
  Canvas->Font->Color = clWhite;
  Canvas->TextOut(w2 - (Canvas->TextWidth(GetCharAtPos(i,Caption)) / 2),i * 10 - 4,GetCharAtPos(i,Caption));
 }
}

AnsiString __fastcall FVolumeControl::FHorzLabel::GetCharAtPos(int i,AnsiString s) {
 s.SetLength(i);
 s = strrev(s.c_str());
 s.SetLength(1);
 return s;
}

// ------------- FCustomButton -------------------------------------------------
__fastcall FVolumeControl::FCustomButton::FCustomButton(TComponent *Owner)
	: TCustomControl(Owner) {
 MouseOver = false;
 MouseD = false;
 rect.Left = 0;
 rect.Top = 0;
 rect.Right = 0;
 rect.Bottom = 0;
 Canvas->Font->Color = clWhite;
 Canvas->Font->Style = Canvas->Font->Style << fsBold;
}

void __fastcall FVolumeControl::FCustomButton::MouseDown(TMouseButton b,TShiftState,int,int) {
 if (b == mbLeft) { MouseD = true; Repaint(); }
}

void __fastcall FVolumeControl::FCustomButton::MouseUp(TMouseButton b,TShiftState,int,int) {
 if (b == mbLeft) { MouseD = false; Repaint(); }
}

void __fastcall FVolumeControl::FCustomButton::CMMouseEnter(TMessage *) {
 MouseOver = true; Repaint();
}

void __fastcall FVolumeControl::FCustomButton::CMMouseLeave(TMessage *) {
 MouseOver = false; Repaint();
}

void __fastcall FVolumeControl::FCustomButton::Paint() {
 if (!MouseD) {
  Canvas->Pen->Color = clBlack;
  Canvas->Brush->Color = clBlack;
  switch (MouseOver) {
   case true:
    Canvas->FillRect(rect);
    Canvas->MoveTo(0,Height -1);
    Canvas->Pen->Color = clWhite;
    Canvas->LineTo(0,0);
    Canvas->LineTo(Width - 1,0);
    Canvas->Pen->Color = clGray;
    Canvas->LineTo(Width - 1, Height - 1);
    Canvas->LineTo(0,Height - 1);
    Canvas->Font->Color = clWhite;
    Canvas->TextOut(5,1,"<<<");
    return;
   case false:
    Canvas->FillRect(rect);
    Canvas->Font->Color = clGray;
    Canvas->TextOut(5,1,"<<<");
    return;
  }
 }
 Canvas->FillRect(rect);
 Canvas->MoveTo(0,Height -1);
 Canvas->Pen->Color = clGray;
 Canvas->LineTo(0,0);
 Canvas->LineTo(Width - 1,0);
 Canvas->Pen->Color = clSilver;
 Canvas->LineTo(Width - 1, Height - 1);
 Canvas->LineTo(0,Height - 1);
 Canvas->Font->Color = clRed;
 Canvas->TextOut(5,1,"<<<");
}

void __fastcall FVolumeControl::FCustomButton::SetBounds(int l,int t,int w,int h) {
 TCustomControl::SetBounds(l,t,w,h);
 rect.Left = l;
 rect.Top = t;
 rect.Right = w;
 rect.Bottom = h;
}

// ------------- FShadowLabel --------------------------------------------------

__fastcall FVolumeControl::FShadowLabel::FShadowLabel(TComponent *Owner)
	: TGraphicControl(Owner) {
 FCaption = "Volume Control";
 MouseOver = false;
}

void __fastcall FVolumeControl::FShadowLabel::SetCaption(AnsiString s) {
 if (FCaption != s) { FCaption = s; Repaint(); }
}

void __fastcall FVolumeControl::FShadowLabel::Paint() {
 Canvas->Font->Size = 24;
 Canvas->Font->Name = "MS Sanf Serif";
 Canvas->Font->Style = Canvas->Font->Style << fsBold;
 Canvas->Brush->Style = bsClear;
 switch(MouseOver) {
  case true:
   Canvas->Font->Color = clGray;
   Canvas->TextOut(2,2,FCaption);
   Canvas->Font->Color = clWhite;
   Canvas->TextOut(0,0,FCaption);
   return;
  case false:
   Canvas->Font->Color = clGray;
   Canvas->TextOut(2,2,FCaption);
   Canvas->Font->Color = clSilver;
   Canvas->TextOut(0,0,FCaption);
   return;
 }
}

void __fastcall FVolumeControl::FShadowLabel::CMMouseEnter(TMessage *) {
 MouseOver = true; Repaint();
}

void __fastcall FVolumeControl::FShadowLabel::CMMouseLeave(TMessage *) {
 MouseOver = false; Repaint();
}

void __fastcall FVolumeControl::FShadowLabel::SetBounds(int l,int t,int w,int h) {
 Canvas->Font->Size = 24;
 Canvas->Font->Name = "MS Sanf Serif";
 Canvas->Font->Style = Canvas->Font->Style << fsBold;
 Canvas->Brush->Style = bsClear;
 if (w > Canvas->TextWidth(FCaption)) { w = Canvas->TextWidth(FCaption); }
 TGraphicControl::SetBounds(l,t,w,h);
}

// ------------- FMover --------------------------------------------------------

__fastcall FVolumeControl::FSlider::FMover::FMover(TComponent *Owner)
	: TGraphicControl(Owner) {
 p[0].x = 0;
 p[1].x = 0;
 p[2].x = 1;
 p[3].x = 2;
 p[4].x = 4;
 p1[0].x = 0;
 p1[1].x = 0;
 p1[2].x = 1;
 p1[3].x = 2;
 p1[4].x = 4;
 p[5].x = 15;
 p[6].x = 15;
 p[7].x = 14;
 p[8].x = 13;
 p[9].x = 11;
 p2[0].x = 15;
 p2[1].x = 15;
 p2[2].x = 14;
 p2[3].x = 13;
 p2[4].x = 11;
 p[0].y = 8;
 p[1].y = 4;
 p[2].y = 2;
 p[3].y = 1;
 p[4].y = 0;
 p1[0].y = 8;
 p1[1].y = 4;
 p1[2].y = 2;
 p1[3].y = 1;
 p1[4].y = 0;
 p[5].y = 0;
 p[6].y = 4;
 p[7].y = 6;
 p[8].y = 7;
 p[9].y = 8;
 p2[0].y = 0;
 p2[1].y = 4;
 p2[2].y = 6;
 p2[3].y = 7;
 p2[4].y = 8;
}

void __fastcall FVolumeControl::FSlider::FMover::Paint() {
 Canvas->Pen->Color = 0x00a0a0a0;
 Canvas->Brush->Color = 0x00a0a0a0;
 Canvas->Brush->Style = bsSolid;
 Canvas->Polygon(p,9);
 Canvas->Pen->Color = clWhite;
 Canvas->Polyline(p1,5);
 Canvas->Pen->Color =clBlack;
 Canvas->Polyline(p2,5);
}
